// DiiDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DiiDemo.h"
#include "DiiDemoDlg.h"

#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiiDemoDlg dialog


IMPLEMENT_DYNAMIC (CDiiDemoDlg,CPropertySheet);


CDiiDemoDlg::CDiiDemoDlg(CWnd* pParent /*=NULL*/)
	: CPropertySheet(IDS_PROPERTY_SHEET_CAPTION, pParent)
{
	//{{AFX_DATA_INIT(CDiiDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//
	// Add our propertypages here:
	//

	AddPage (&m_dioPage);
	AddPage (&m_aioPage);
	AddPage (&m_timerPage);
	AddPage (&m_pulseCountPage);
	AddPage (&m_anaBlockIoPage);
	AddPage (&m_blockIoPage);
}


BEGIN_MESSAGE_MAP(CDiiDemoDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CDiiDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiiDemoDlg message handlers

void CDiiDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CPropertySheet::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDiiDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPropertySheet::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDiiDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CDiiDemoDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertySheet::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return 0;
}

int CDiiDemoDlg::DoModal() 
{

		// ------------------------------------------------------------------
		//                        DII Library Calls:
		//
		// Our Task here:
		// Ask the user what device he would like to open:
		//
		// ------------------------------------------------------------------

	CString strDeviceName;
	
	if (!DiiSelectDevice (NULL,strDeviceName.GetBufferSetLength (200),200))
	{
		strDeviceName.ReleaseBuffer(0);

		return IDCANCEL;
	}

	strDeviceName.ReleaseBuffer();


		//
		// Now attempt to open the device:
		//


	m_hDevice = DiiOpenNamedDevice (strDeviceName, FALSE);

		//
		// See if we were able to aquire the device:
		//

	if (m_hDevice == INVALID_HANDLE_VALUE)
	{
		CString strMsg;

		strMsg.Format (IDS_CANNOT_OPEN_ADAPTER,LPCTSTR (strDeviceName));

		AfxMessageBox (strMsg);

		return IDCANCEL;
	}

		//
		// Otherwise proceed with the testing:
		//
	
	int iResult = CPropertySheet::DoModal();

		//
		// Finally close the device again:
		//

	DiiCloseDevice (m_hDevice);

	m_hDevice = INVALID_HANDLE_VALUE;

	return iResult;
}
